﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net.Http;
using System.Net.Http.Headers;

using Newtonsoft.Json;

namespace TestClient
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Console.Title = "대용량 데이터를 스트리밍 방식으로 전달받기";

            Console.WriteLine("PRESS ANY KEY TO CONTINUE...");

            Console.ReadKey(true);

            foreach(ValueModel value in GetValueEnumerable())
            {
                Console.WriteLine("{0}\t{1}", value.SequenceID, value.Data);
            }

            Console.WriteLine("PRESS ANY KEY TO EXIT...");

            Console.ReadKey(true);
        }

        #endregion
        #region 값 열거 가능형 구하기 - GetValueEnumerable()

        /// <summary>
        /// 값 열거 가능형 구하기
        /// </summary>
        /// <returns>값 열거 가능형</returns>
        private static IEnumerable<ValueModel> GetValueEnumerable()
        {
            JsonSerializer serializer = new JsonSerializer();

            HttpClient client = new HttpClient();

            MediaTypeWithQualityHeaderValue headerValue = new MediaTypeWithQualityHeaderValue("application/json");

            client.DefaultRequestHeaders.Accept.Add(headerValue);

            using(Stream stream = client.GetStreamAsync("http://localhost:63025/api/value").Result)
            {
                using(StreamReader streamReader = new StreamReader(stream))
                {
                    using(JsonTextReader jsonTextReader = new JsonTextReader(streamReader))
                    {
                        while(jsonTextReader.Read())
                        {
                            if(jsonTextReader.TokenType != JsonToken.StartArray && jsonTextReader.TokenType != JsonToken.EndArray)
                            {
                                yield return serializer.Deserialize<ValueModel>(jsonTextReader);
                            }
                        }
                    }
                }
            }
        }

        #endregion
    }
}