﻿using System.Net.Http;
using System.Threading;
using System.Threading.Tasks;

namespace TestServer.Handlers
{
    /// <summary>
    /// 값 핸들러
    /// </summary>
    public class ValueHandler : DelegatingHandler
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 비동기 송신하기 - SendAsync(requestMessage, cancellationToken)

        /// <summary>
        /// 비동기 송신하기
        /// </summary>
        /// <param name="requestMessage">HTTP 요청 메시지</param>
        /// <param name="cancellationToken">취소 토큰</param>
        /// <returns>HTTP 응답 메시지 태스크</returns>
        protected override Task<HttpResponseMessage> SendAsync(HttpRequestMessage requestMessage, CancellationToken cancellationToken)
        {
            Task<HttpResponseMessage> responseMessageTask = base.SendAsync(requestMessage, cancellationToken);
            
            responseMessageTask.Result.Headers.TransferEncodingChunked = true;
            
            return responseMessageTask;
        }

        #endregion
    }
}